package org.apache.portals.applications.springmvc;

import java.util.HashMap;
import java.util.Map;

import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;

import org.springframework.beans.factory.InitializingBean;
import org.springframework.web.portlet.mvc.AbstractController;
import org.springframework.web.portlet.ModelAndView;

public class DOMTreePrefsListController extends AbstractController implements InitializingBean
{
	private DOMTreeService domTreeService;
    
    public void afterPropertiesSet() throws Exception
    {
        if (this.domTreeService == null)
            throw new IllegalArgumentException( "A DOMTreeService is required" );
    }
    
	public ModelAndView handleRenderRequestInternal( RenderRequest request, RenderResponse response ) throws Exception
	{
		Map model = new HashMap();
		model.put( "list", domTreeService.getAllDOMTrees( request ) );
        return new ModelAndView( "domTreeEditList", "model", model );
	}

	public void setDomTreeService( DOMTreeService domTreeService )
    {
        this.domTreeService = domTreeService;
    }
}
